(function(WGo) {
	var PatternSearch = function(player, board, callback) {
		this.player = player;
		this.board = board;
		this.callback = callback || null;
		this.init();
	}
	PatternSearch.prototype = {
		//画布元素
		element: null,
		//画布内容
		context: null,
		//初始化化方法
		init: function() {
			var board = this.board,
				player = this.player,
				element = document.createElement('canvas'),
				context = element.getContext('2d');
			//初始化画布属性
			element.style.position = 'absolute';
			element.style.zIndex = 100;
			element.width = board.width;
			element.height = board.width;
			element.style.width = board.width / board.pixelRatio + 'px';
			element.style.height = board.height / board.pixelRatio + 'px';
			board.element.appendChild(element);
			this.element = element;
			this.context = context;
		},

		// 绘制方法
		drawArea: function(player) {
			var x = 0,
				fieldWidth = this.board.fieldWidth,
				path = '',
				areaWidth = 0;
			path = this.player.kifuReader.path.m + 0.5
			if (this.player.kifuReader.path.m < 6) {
				x = this.board.getX(7) - fieldWidth * path
				areaWidth = fieldWidth * path * 2
			}
			this.element.style.zIndex = 100;
			this.context.clearRect(x, x, this.element.width, this.element.height);
			this.context.fillStyle = 'rgba(123,201,219,0.4)';
			this.context.beginPath();
			this.context.fillRect(x, x, areaWidth, areaWidth);
			this.context.stroke();
		},
		stoneMarker: function(args) {
			var xr = this.board.getX(args.x),
				yr = this.board.getY(args.y),
				sr = this.board.stoneRadius;
			this.context.clearRect(0, 0, this.element.width, this.element.height);
			this.element.style.zIndex = 500;
			this.context.lineWidth = 5;
			this.context.strokeStyle = 'red';
			this.context.beginPath();
			this.context.arc(xr - this.board.ls, yr - this.board.ls, Math.min(this.board.fieldWidth, this.board.fieldHeight) /
				2, 0, 2 * Math.PI, true);
			this.context.stroke();
		},

		//关闭绘制
		close: function() {
			if (this.context) this.context.clearRect(0, 0, this.element.width, this.element.height);
		}
	}
	WGo.Player.PatternSearch = PatternSearch
})(WGo)
