/**
 * Created by larry on 2017/1/6.
 */
(function(WGo) {
	var tryMove = function(player, board, marker, trySgf) {
		this.oldMark = {};
		this.player = player;
		this.board = board;
		this.marker = marker;
		this.isPlayVoice = true;
		this.trySgf = trySgf || '';
		this.isDrop = marker.isDrop ? marker.isDrop : 0; // 落子状态 0 交换落子 1 落黑子 -1 落白子
		this.isPro = marker.isPro ? true : false; // 是否职业
		this.komiN = marker.komiN ? marker.komiN : 2; // 5手N打
		this.openCallBack = false;
		this.firSymmetric = null;
		this.preplayMove = null;
		this.isPreplay = marker.isPreplay;
		this.markerStyle = marker.style || 'LB'
		this.init();
	};
	var state = {
		BLACK_STONE: 1, // must be equal to WGo.B
		WHITE_STONE: -1, // must be equal to WGo.W
	};

	// 校测对称点
	class FirSymmetric {
		constructor() {
			this.isSymmetric = false
			//初始四颗子
			this.originStoneArr = []
			//N打的子
			this.tryStoneArr = []
			//N打棋面平移过后的子
			this.movedStoneArr = []
			//当前N打局面的八个方向
			this.testStoneArr = {
				og: [], //初始
				x: [], //x轴翻转
				y: [], //y轴翻转
				left: [], //左对角线翻转
				right: [], //右对角线翻转
				nine: [], //逆时针90度
				eighteen: [], //逆时针180度
				twentyseven: [] //逆时针270度
			}
		};

		clear() {
			this.originStoneArr = []
			this.tryStoneArr = []
			this.movedStoneArr = []
		};

		//弈客的棋谱控件的turn是下手颜色这里得注意
		playStone(x, y, c) {
			this.isSymmetric = false
			var stone = {
				x: x,
				y: y,
				c: c,
			}
			if (this.originStoneArr.length < 4) {
				this.originStoneArr.push(stone)
			} else {
				var arr = this.tryStoneArr.filter(item => item.x == x && item.y == y)
				if (arr.length > 0) return false;
				this.tryStoneArr.push(stone)
			}
			if (this.tryStoneArr.length > 0) {
				this.moveOriginStone()
			}
			if (this.tryStoneArr.length > 1) {
				this.makeSymmetricStone()
			}
			return this.isSymmetric
		};

		//平移当前N打手盘面
		moveOriginStone() {
			var stoneArr = this.originStoneArr.concat(this.tryStoneArr[this.tryStoneArr.length - 1])
			this.movedStoneArr.push(this.moveStoneArr(stoneArr))
		};

		//平移盘面方法
		moveStoneArr(arr) {
			var stoneArr = arr
			var xArr = []
			var yArr = []
			var movedArr = []
			for (var i in stoneArr) {
				xArr.push(stoneArr[i].x)
				yArr.push(stoneArr[i].y)
			}
			var xMin = Math.min.apply(null, xArr);
			var yMin = Math.min.apply(null, yArr);
			for (var i in stoneArr) {
				var move = ''
				if (stoneArr[i].c == 1) {
					move = 'b' + 'x' + (stoneArr[i].x - xMin).toString() + 'y' + (stoneArr[i].y - yMin).toString()
				} else {
					move = 'w' + 'x' + (stoneArr[i].x - xMin).toString() + 'y' + (stoneArr[i].y - yMin).toString()
				}

				movedArr.push(move)
			}
			return movedArr
		};

		//获得N打当前手的八种图形
		makeSymmetricStone() {
			var arr = ['x', 'y', 'left', 'right', 'nine', 'eighteen', 'twentyseven']
			this.testStoneArr.og = this.originStoneArr.concat(this.tryStoneArr[this.tryStoneArr.length - 1])
			var stoneArr = this.testStoneArr.og
			for (var k in arr) {
				this.testStoneArr[arr[k]] = []
				for (var i = 0; i < stoneArr.length; i++) {
					var stone = {
						x: '',
						y: '',
						c: stoneArr[i].c,
					}
					if (arr[k] == 'x') {
						if (stoneArr[i].y > 7) {
							stone.y = parseInt(stoneArr[i].y - (Math.abs(stoneArr[i].y - 7) * 2))
						} else if (stoneArr[i].y < 7) {
							stone.y = parseInt(stoneArr[i].y + (Math.abs(stoneArr[i].y - 7) * 2))
						} else {
							stone.y = stoneArr[i].y
						}
						stone.x = stoneArr[i].x
						this.testStoneArr['x'].push(stone)
					}
					if (arr[k] == 'y') {
						if (stoneArr[i].x > 7) {
							stone.x = parseInt(stoneArr[i].x - (Math.abs(stoneArr[i].x - 7) * 2))
						} else if (stoneArr[i].x < 7) {
							stone.x = parseInt(stoneArr[i].x + (Math.abs(stoneArr[i].x - 7) * 2))
						} else {
							stone.x = stoneArr[i].x
						}
						stone.y = stoneArr[i].y
						this.testStoneArr['y'].push(stone)
					}
					if (arr[k] == 'right') {
						stone.x = 14 - stoneArr[i].y;
						stone.y = 14 - stoneArr[i].x;
						this.testStoneArr['right'].push(stone)
					}
					if (arr[k] == 'left') {
						stone.x = stoneArr[i].y;
						stone.y = stoneArr[i].x;
						this.testStoneArr['left'].push(stone)
					}
					if (arr[k] == 'nine') {
						stone.x = Math.round((stoneArr[i].x - 7) * Math.cos(Math.PI / 2) - (stoneArr[i].y - 7) * Math.sin(Math.PI / 2) +
							7);
						stone.y = Math.round((stoneArr[i].x - 7) * Math.sin(Math.PI / 2) + (stoneArr[i].y - 7) * Math.cos(Math.PI / 2) +
							7);
						this.testStoneArr['nine'].push(stone)
					}
					if (arr[k] == 'eighteen') {
						stone.x = Math.round((stoneArr[i].x - 7) * Math.cos(Math.PI) - (stoneArr[i].y - 7) * Math.sin(Math.PI) + 7);
						stone.y = Math.round((stoneArr[i].x - 7) * Math.sin(Math.PI) + (stoneArr[i].y - 7) * Math.cos(Math.PI) + 7);
						this.testStoneArr['eighteen'].push(stone)
					}
					if (arr[k] == 'twentyseven') {
						stone.x = Math.round((stoneArr[i].x - 7) * Math.cos(Math.PI / 2 * 3) - (stoneArr[i].y - 7) * Math.sin(Math.PI /
							2 * 3) + 7);
						stone.y = Math.round((stoneArr[i].x - 7) * Math.sin(Math.PI / 2 * 3) + (stoneArr[i].y - 7) * Math.cos(Math.PI /
							2 * 3) + 7);
						this.testStoneArr['twentyseven'].push(stone)
					}
				}
			}
			this.moveSymmetricStone()
		};

		//平移八种图形
		moveSymmetricStone() {
			//当前N打的棋型
			var curNStoneArr = []
			for (var k in this.testStoneArr) {
				curNStoneArr.push(this.moveStoneArr(this.testStoneArr[k]))
			}
			this.checkSymmetric(curNStoneArr)
		};

		//检查对称
		checkSymmetric(curArr) {
			//待比较棋型数组
			var staticStoneArr = this.movedStoneArr
			var arr = []
			for (var i in curArr) {
				var checkObj = {
					count: 0,
					value: curArr[i].join('')
				}
				arr.push(checkObj)
			}
			for (var l = 0; l < staticStoneArr.length - 1; l++) {
				for (var m in arr) {
					arr[m].count = 0
				}
				//当前N打棋型和先前棋型作比较，count为匹配值，count值为5则全部匹配
				for (var k = 0; k < staticStoneArr[l].length; k++) {
					for (var j = 0; j < arr.length; j++) {
						if (arr[j].value.indexOf(staticStoneArr[l][k]) != -1) {
							arr[j].count += 1
							if (arr[j].count >= 5) {
								this.tryStoneArr.splice(this.tryStoneArr.length - 1, 1)
								this.movedStoneArr.splice(this.movedStoneArr.length - 1, 1)
								this.isSymmetric = true
								break;
							}
						}
					}
				}
			}
		};
	}

	tryMove.prototype = {
		init: function() {
			this.sgf = this.player.kifuReader.kifu.toSgf();
			this.curPos = this.player.kifuReader.path.m;
			// this.oldMark.branchPath = this.marker.config.branchPath;
			// this.oldMark.lastMoveColor = this.marker.config.lastMoveColor;
			// this.oldMark.markerNum = this.marker.config.markerNum;
			// this.oldMark.markerStyle = this.marker.config.markerStyle;
			// this.oldMark.start = this.marker.config.start;
			var turn = this.player.kifuReader.game.turn;
			var p = this.player.kifuReader.game.position;
			var bs = [],
				ws = [];
			for (var i = 0; i < p.size; i++) {
				for (var j = 0; j < p.size; j++) {
					s = p.get(j, i);
					var x1 = String.fromCharCode(j + 97);
					var y1 = String.fromCharCode(i + 97);
					if (s == state.BLACK_STONE) {
						bs.push("[" + x1 + "" + y1 + "]");
					} else if (s == state.WHITE_STONE) {
						ws.push("[" + x1 + "" + y1 + "]");
					}
				}
			}
			this.marker.switchMaker({
				markerStyle: this.markerStyle, // TO DO 这里改过，之前默认是LB
				markerNum: 0
			});
			var AB = bs.length > 0 ? bs.join(' ') : '[]';
			var AW = ws.length > 0 ? ws.join(' ') : '[]';
			var sgf = "(;SZ[" + this.player.kifuReader.kifu.size + "]AB" + AB + "AW" + AW + this.trySgf + ")";
			this.isPlayVoice = true;
			this.player.loadSgf(sgf);
			this.player.last();
			this.isPlayVoice = false;
			this.preplayMove = null
			this.player.kifuReader.game.turn = turn;
			this.player.kifuReader.game.position.capCount = p.capCount;
			this.firSymmetric = new FirSymmetric()
			if (!this._bind_evn) this._bind_evn = this.play.bind(this);

			//          this._ev_move = this._ev_move || edit_board_mouse_move.bind(this);
			//          this._ev_out = this._ev_out || edit_board_mouse_out.bind(this)；
			this.board.addEventListener("click", this._bind_evn);
			//          this.board.addEventListener("mousemove", this._ev_move);
			//          this.board.addEventListener("mouseout", this._ev_out);
		},
		play: function(x, y, click) {
			var color = this.isDrop === 0 ? this.player.kifuReader.game.turn : this.isDrop;
			if (this.isPro) {
				if (this.isPreplay) {
					// 不能大于打点数
					if (this.player.kifuReader.path.m + 1 > this.komiN) return;
					if (this.preplayMove) {
						let preplayMove = this.preplayMove
						this.removeStoneObject()
						if (preplayMove.x === x && preplayMove.y === y) {
							if (!this.checkFirSymmetric(x, y, color, click)) return;
							this.playMove(x, y)
						} else {
							this.addStoneObject(x, y, color)
						}
					} else {
						let tryStone = this.firSymmetric.tryStoneArr.some(item => item.x === x && item.y === y)
						if (tryStone) return;
						this.addStoneObject(x, y, color)
					}
				} else {
					if (!this.checkFirSymmetric(x, y, color, click)) return;
					this.playMove(x, y)
				}
			} else {
				this.playMove(x, y)
			}
		},

		playMove: function(x, y) {
			var color = this.isDrop === 0 ? this.player.kifuReader.game.turn : this.isDrop;
			if (this.player.frozen || !this.player.kifuReader.game.isValid(x, y) || (this.editMode == false)) return;
			this.player.kifuReader.node.appendChild(new WGo.KNode({
				move: {
					x: x,
					y: y,
					c: color
				},
				_edited: true
			}));
			this.player.kifu.nodeCount++
			this.player.next(this.player.kifuReader.node.children.length - 1);
		},
		pass: function(x, y, c) {
			x = x || -1;
			y = y || -1;
			if (this.player.frozen) return;
			this.player.kifuReader.node.appendChild(new WGo.KNode({
				move: {
					pass: true,
					c: c || this.player.kifuReader.game.turn
				},
				_edited: true
			}));
			this.player.kifuReader.kifu.nodeCount++;
			this.player.next(this.player.kifuReader.node.children.length - 1);
			this.playcb && this.playcb(x, y, 'pass');
		},
		endTry: function(curPos) {
			this.isPro = false;
			this.isDrop = 0;
			this.isPreplay = false;
			this.preplayMove = null;
			this.marker.switchMaker(this.oldMark);
			this.isPlayVoice = true;
			this.player.loadSgf(this.sgf);
			this.player.goTo(curPos || this.curPos);
			this.isPlayVoice = false;
			this.board.removeEventListener("click", this._bind_evn);
			var sgf = this.player.kifuReader.kifu.toSgf();
			return sgf;
		},

		// 校验规则
		checkFirSymmetric: function(x, y, c, click) {
			if (this.isPro) {
				let arr = this.player.kifuReader.kifu.root.setup
				this.firSymmetric.originStoneArr = arr
				let moves1 = arr.filter(item => item.x === x && item.y === y)
				if (moves1.length > 0) return false;
				let moves2 = this.firSymmetric.tryStoneArr.filter(item => item.x === x && item.y === y)
				let isSymmetric = this.firSymmetric.playStone(x, y, c)
				if (this.openCallBack && click && click.type === 'click') {
					this.callback && this.callback({
						x: x,
						y: y,
						c: c,
						type: isSymmetric ? 'symmetric' : 'tryMoveDown'
					});
					if (moves2.length > 0 || isSymmetric) return false;
				}
				if (this.player.kifuReader.path.m + 1 > this.komiN) return false;
			}
			return true;
		},
		setCallback: function(callback) {
			this.callback = callback
		},
		addStoneObject: function(x, y, c) {
			this.board.addObject([{
				x: x,
				y: y,
				c: c,
				type: 'outline'
			}]);
			this.preplayMove = {
				x: x,
				y: y,
				c: c
			}
		},
		removeStoneObject: function() {
			let preplayMove = this.preplayMove
			this.board.removeObject({
				x: preplayMove.x,
				y: preplayMove.y,
				c: preplayMove.c,
				type: 'outline'
			});
			this.preplayMove = null;
		},
		clear() {
			this.preplayMove = null;
			this.firSymmetric.clear()
		}
	};
	WGo.TryMove = tryMove;
})(WGo)
